/* =================================================================================
 *  liste.h
 * =================================================================================
 * Contiene la definizione del tipo lista e il prototipo di funzioni/procedure per:
 * - costruire una lista di interi
 * - stampare il contenuto di una lista di interi
 * - verificare l'ordinamento di una lista di interi
 * - calcolare l'intersezione di due liste di interi non ordinate
 * - calcolare l'intersezione di due liste di interi ordinate
 *
 *  Author:      Irene Finocchi  (finocchi@di.uniroma1.it)
 *  Last change: 18 Aprile 2005
 *  Changed by:  Irene Finocchi
*/

#ifndef LISTA_H
#define LISTA_H

#include <stdio.h>
#include<stdlib.h>

/* Tipo lista */

struct nodolista{
	int elem;
	struct nodolista *next;
};

typedef struct nodolista *ListPtr;

/* Prototipi */

/* Costruzione di una lista di caratteri da input */
ListPtr crealista();

/* Post: stampa il contenuto della lista */
void stampaLista(ListPtr L);

/* Post: restituisce 1 se la lista e' ordinata in modo non decrescente
         e 0 altrimenti */
int verificaOrdinamento(ListPtr L);

/* Post: restituisce la lista intersezione di due liste di interi non ordinate */
ListPtr intersezione(ListPtr L1, ListPtr L2);

/* Pre:  le liste L1 e L2 sono ordinate in ordine non decrescente e non 
         contengono elementi duplicati */
/* Post: restituisce la lista intersezione */
ListPtr intersezioneOrdinate(ListPtr L1, ListPtr L2);

#endif
